local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/MapHeightPeninsula.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_c.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_Peninsula_2020",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -25,
	MaxHeight = 72,
	VillagePathList = {
		{
			Entrance = { 15, 0, 988 },
			Exit = { 15, 0, 988 }
		},
		{
			Entrance = { 1005, 0, 967 },
			Exit = { 1005, 0, 967 }
		},
		{
			Entrance = { 750, 0, 1010 },
			Exit = { 750, 0, 1010 }
		},
		{
			Entrance = { 442, 0, 1012 },
			Exit = { 442, 0, 1012 }
		},
	},
	SpawnList = {
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 576, 21, 716 },
			Orientation = { 0.0, 290.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 594, 31, 708 },
			Orientation = { 0.0, 295.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 615, 32, 722 },
			Orientation = { 0.0, 300.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 618, 35, 408 },
			Orientation = { 0.0, 50.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 641, 30, 423 },
			Orientation = { 0.0, 80.0, 0.0 }
		},

		--Hill up right
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 635, 18, 921 },
			Orientation = { 0.0, 80.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 643, 15, 936 },
			Orientation = { 0.0, 80.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 649, 14, 848 },
			Orientation = { 0.0, 70.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 652, 19, 833 },
			Orientation = { 0.0, 70.0, 0.0 }
		},

		--Hill up left
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 584, 26, 841 },
			Orientation = { 0.0, 210.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 538, 13, 882 },
			Orientation = { 0.0, 210.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 571, 25, 857 },
			Orientation = { 0.0, 240.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 562, 23, 928 },
			Orientation = { 0.0, 280.0, 0.0 }
		},

		--Hill middle right
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 649, 13, 595 },
			Orientation = { 0.0, 70.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 645, 13, 615 },
			Orientation = { 0.0, 100.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 653, 12, 627 },
			Orientation = { 0.0, 90.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 647, 12, 644 },
			Orientation = { 0.0, 90.0, 0.0 }
		},

		--Hill middle left
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 590, 16, 531 },
			Orientation = { 0.0, 240.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 595, 18, 546 },
			Orientation = { 0.0, 230.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 575, 14, 506 },
			Orientation = { 0.0, 220.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 579, 26, 438 },
			Orientation = { 0.0, 220.0, 0.0 }
		},
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.85,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})